import json
import os

DREAM_LOG_PATH = "memory/dreams.json"


def load_dreams():
    if not os.path.exists(DREAM_LOG_PATH):
        return []
    try:
        with open(DREAM_LOG_PATH, "r", encoding="utf-8") as f:
            return json.load(f)
    except json.JSONDecodeError:
        print("[Dreams] Failed to parse dreams.json.")
        return []


def save_dream(sentence: str, score: float):
    dreams = load_dreams()
    dreams.append({"sentence": sentence, "score": round(score, 2)})
    dreams = sorted(dreams, key=lambda x: x["score"], reverse=True)[:100]
    with open(DREAM_LOG_PATH, "w", encoding="utf-8") as f:
        json.dump(dreams, f, indent=2)
